%{
/* lexical analizer for asm3v ver.1.0 ['92/Aug./3-11] */
/* 			      ver.1.2 ['92/Aug./24]   */
/* 			      ver.1.3 ['92/Sep./1-2]  */
/* 			      ver.1.3R['93/Oct./26]   */

/* lexical analizer for asm4v ver.1.0 ['94/Jun./10] */
/*			      ver.1.1 ['94/Dec./9] */
/*			      ver.1.2 ['95/Jan./4] */

#include <string.h>
#include <math.h>
#include "y.tab.h"
#include "regdef.h"
#include "specialreg.h"

#define	HEXSTRLEN	10
#define	BINSTRLEN	34
#define LINESIZE	255
#define STRSIZE	64

extern void	lexerror();
extern void	addline();
extern void	allupper();
extern int	htoi();
extern int	btoi();

int strcnt = 0;
char	string[STRSIZE + 1] = {0};

int lineptr = 0;
char	linebuff[LINESIZE + 1] = {0};

%}
A	[Aa]
B	[Bb]
C	[Cc]
D	[Dd]
E	[Ee]
F	[Ff]
G	[Gg]
H	[Hh]
I	[Ii]
J	[Jj]
K	[Kk]
L	[Ll]
M	[Mm]
N	[Nn]
O	[Oo]
P	[Pp]
Q	[Qq]
R	[Rr]
S	[Ss]
T	[Tt]
U	[Uu]
V	[Vv]
W	[Ww]
X	[Xx]
Y	[Yy]
Z	[Zz]
DECIMAL		[0-9]
NZDECIMAL	[1-9]
HEXA		[0-9A-Fa-f]
EXP	({E}[+-]?{DECIMAL}+)
%e 4000
%p 5000
%a 5000
%o 5000
%start COMMENT STR
%%
<INITIAL>{L}{D}{I}	{
			addline(yytext);
			return(LDI);
			}
<INITIAL>{L}{D}		{
			addline(yytext);
			return(LD);
			}
<INITIAL>{L}{D}{B}	{
			addline(yytext);
			return(LDB);
			}
<INITIAL>{L}{D}{B}{I}	{
			addline(yytext);
			return(LDBI);
			}
<INITIAL>{L}{D}{B}{S}	{
			addline(yytext);
			return(LDBS);
			}
<INITIAL>{L}{D}{P}{C}{B}	{
			addline(yytext);
			return(LDPCB);
			}
<INITIAL>{L}{D}{P}{C}{B}{I}	{
			addline(yytext);
			return(LDPCBI);
			}
<INITIAL>{S}{T}		{
			addline(yytext);
			return(ST);
			}
<INITIAL>{S}{T}{B}	{
			addline(yytext);
			return(STB);
			}
<INITIAL>{S}{T}{B}{I}	{
			addline(yytext);
			return(STBI);
			}
<INITIAL>{S}{T}{B}{S}	{
			addline(yytext);
			return(STBS);
			}
<INITIAL>{S}{T}{P}{C}{B}	{
			addline(yytext);
			return(STPCB);
			}
<INITIAL>{S}{T}{P}{C}{B}{I}	{
			addline(yytext);
			return(STPCBI);
			}
<INITIAL>{A}{D}{D}	{
			addline(yytext);
			return(ADD);
			}
<INITIAL>{A}{D}{D}{I}	{
			addline(yytext);
			return(ADDI);
			}
<INITIAL>{S}{U}{B}	{
			addline(yytext);
			return(SUB);
			}
<INITIAL>{S}{U}{B}{I}	{
			addline(yytext);
			return(SUBI);
			}
<INITIAL>{M}{U}{L}	{
			addline(yytext);
			return(MUL);
			}
<INITIAL>{M}{U}{L}{I}	{
			addline(yytext);
			return(MULI);
			}
<INITIAL>{D}{I}{V}	{
			addline(yytext);
			return(DIV);
			}
<INITIAL>{D}{I}{V}{I}	{
			addline(yytext);
			return(DIVI);
			}
<INITIAL>{M}{O}{D}	{
			addline(yytext);
			return(MOD);
			}
<INITIAL>{M}{O}{D}{I}	{
			addline(yytext);
			return(MODI);
			}
<INITIAL>{R}{S}{U}{B}	{
			addline(yytext);
			return(RSUB);
			}
<INITIAL>{R}{S}{U}{B}{I}	{
			addline(yytext);
			return(RSUBI);
			}
<INITIAL>{U}{M}{U}{L}	{
			addline(yytext);
			return(UMUL);
			}
<INITIAL>{U}{M}{U}{L}{I}	{
			addline(yytext);
			return(UMULI);
			}
<INITIAL>{U}{D}{I}{V}	{
			addline(yytext);
			return(UDIV);
			}
<INITIAL>{U}{D}{I}{V}{I}	{
			addline(yytext);
			return(UDIVI);
			}
<INITIAL>{A}{N}{D}	{
			addline(yytext);
			return(AND);
			}
<INITIAL>{A}{N}{D}{I}	{
			addline(yytext);
			return(ANDI);
			}
<INITIAL>{O}{R}		{
			addline(yytext);
			return(OR);
			}
<INITIAL>{O}{R}{I}	{
			addline(yytext);
			return(ORI);
			}
<INITIAL>{X}{O}{R}	{
			addline(yytext);
			return(XOR);
			}
<INITIAL>{X}{O}{R}{I}	{
			addline(yytext);
			return(XORI);
			}
<INITIAL>{N}{O}{T}	{
			addline(yytext);
			return(NOT);
			}
<INITIAL>{S}{R}{L}	{
			addline(yytext);
			return(SRL);
			}
<INITIAL>{S}{R}{L}{I}	{
			addline(yytext);
			return(SRLI);
			}
<INITIAL>{S}{L}{L}	{
			addline(yytext);
			return(SLL);
			}
<INITIAL>{S}{L}{L}{I}	{
			addline(yytext);
			return(SLLI);
			}
<INITIAL>{S}{R}{A}	{
			addline(yytext);
			return(SRA);
			}
<INITIAL>{S}{R}{A}{I}	{
			addline(yytext);
			return(SRAI);
			}
<INITIAL>{S}{L}{A}	{
			addline(yytext);
			return(SLA);
			}
<INITIAL>{S}{L}{A}{I}	{
			addline(yytext);
			return(SLAI);
			}
<INITIAL>{F}{A}{D}{D}	{
			addline(yytext);
			return(FADD);
			}
<INITIAL>{F}{S}{U}{B}	{
			addline(yytext);
			return(FSUB);
			}
<INITIAL>{F}{M}{U}{L}	{
			addline(yytext);
			return(FMUL);
			}
<INITIAL>{F}{D}{I}{V}	{
			addline(yytext);
			return(FDIV);
			}
<INITIAL>{I}{N}{T}	{
			addline(yytext);
			return(INT);
			}
<INITIAL>{F}{L}{T}	{
			addline(yytext);
			return(FLT);
			}
<INITIAL>{J}{M}{P}	{
			addline(yytext);
			return(JMP);
			}
<INITIAL>{J}{C}		{
			addline(yytext);
			return(JC);
			}
<INITIAL>{J}{R}		{
			addline(yytext);
			return(JMP);
			}
<INITIAL>{J}{R}{C}	{
			addline(yytext);
			return(JC);
			}
<INITIAL>{J}{M}{P}{L}	{
			addline(yytext);
			return(JMPL);
			}
<INITIAL>{J}{C}{L}	{
			addline(yytext);
			return(JCL);
			}
<INITIAL>{J}{R}{L}		{
			addline(yytext);
			return(JMPL);
			}
<INITIAL>{J}{R}{C}{L}	{
			addline(yytext);
			return(JCL);
			}
<INITIAL>{J}{B}		{
			addline(yytext);
			return(JB);
			}
<INITIAL>{J}{B}{C}	{
			addline(yytext);
			return(JBC);
			}
<INITIAL>{J}{B}{L}	{
			addline(yytext);
			return(JBL);
			}
<INITIAL>{J}{B}{C}{L}	{
			addline(yytext);
			return(JBCL);
			}
<INITIAL>{C}{J}{P}	{
			addline(yytext);
			return(CJP);
			}
<INITIAL>{C}{J}{M}	{
			addline(yytext);
			return(CJM);
			}
<INITIAL>{C}{J}{Z}	{
			addline(yytext);
			return(CJZ);
			}
<INITIAL>{C}{J}{N}{Z}	{
			addline(yytext);
			return(CJNZ);
			}
<INITIAL>{C}{J}{P}{I}	{
			addline(yytext);
			return(CJPI);
			}
<INITIAL>{C}{J}{M}{I}	{
			addline(yytext);
			return(CJMI);
			}
<INITIAL>{C}{J}{Z}{I}	{
			addline(yytext);
			return(CJZI);
			}
<INITIAL>{C}{J}{N}{Z}{I}	{
			addline(yytext);
			return(CJNZI);
			}
<INITIAL>{V}{F}{A}{D}{D}	{
			addline(yytext);
			return(VFADD);
			}
<INITIAL>{V}{F}{S}{U}{B}	{
			addline(yytext);
			return(VFSUB);
			}
<INITIAL>{V}{F}{M}{U}{L}	{
			addline(yytext);
			return(VFMUL);
			}
<INITIAL>{V}{F}{D}{I}{V}	{
			addline(yytext);
			return(VFDIV);
			}
<INITIAL>{V}{A}{D}{D}	{
			addline(yytext);
			return(VADD);
			}
<INITIAL>{V}{S}{U}{B}	{
			addline(yytext);
			return(VSUB);
			}
<INITIAL>{V}{M}{U}{L}	{
			addline(yytext);
			return(VMUL);
			}
<INITIAL>{V}{D}{I}{V}	{
			addline(yytext);
			return(VDIV);
			}
<INITIAL>{V}{A}{N}{D}	{
			addline(yytext);
			return(VAND);
			}
<INITIAL>{V}{O}{R}	{
			addline(yytext);
			return(VOR);
			}
<INITIAL>{V}{X}{O}{R}	{
			addline(yytext);
			return(VXOR);
			}
<INITIAL>{V}{N}{O}{T}	{
			addline(yytext);
			return(VNOT);
			}
<INITIAL>{C}{V}{F}{A}{D}{D}	{
			addline(yytext);
			return(CVFADD);
			}
<INITIAL>{C}{V}{F}{S}{U}{B}	{
			addline(yytext);
			return(CVFSUB);
			}
<INITIAL>{C}{V}{F}{M}{U}{L}	{
			addline(yytext);
			return(CVFMUL);
			}
<INITIAL>{C}{V}{F}{D}{I}{V}	{
			addline(yytext);
			return(CVFDIV);
			}
<INITIAL>{C}{V}{A}{D}{D}	{
			addline(yytext);
			return(CVADD);
			}
<INITIAL>{C}{V}{S}{U}{B}	{
			addline(yytext);
			return(CVSUB);
			}
<INITIAL>{C}{V}{M}{U}{L}	{
			addline(yytext);
			return(CVMUL);
			}
<INITIAL>{C}{V}{D}{I}{V}	{
			addline(yytext);
			return(CVDIV);
			}
<INITIAL>{C}{V}{A}{N}{D}	{
			addline(yytext);
			return(CVAND);
			}
<INITIAL>{C}{V}{O}{R}	{
			addline(yytext);
			return(CVOR);
			}
<INITIAL>{C}{V}{X}{O}{R}	{
			addline(yytext);
			return(CVXOR);
			}
<INITIAL>{C}{V}{N}{O}{T}	{
			addline(yytext);
			return(CVNOT);
			}
<INITIAL>{V}{B}{C}{A}{S}{T}	{
			addline(yytext);
			return(VBCAST);
			}
<INITIAL>{V}{S}{R}{L}	{
			addline(yytext);
			return(VSRL);
			}
<INITIAL>{V}{S}{L}{L}	{
			addline(yytext);
			return(VSLL);
			}
<INITIAL>{V}{L}{I}{R}	{
			addline(yytext);
			return(VLIR);
			}
<INITIAL>{V}{L}{I}{I}	{
			addline(yytext);
			return(VLII);
			}
<INITIAL>{V}{S}{I}{R}	{
			addline(yytext);
			return(VSIR);
			}
<INITIAL>{V}{S}{I}{I}	{
			addline(yytext);
			return(VSII);
			}
<INITIAL>{L}{V}{L}{D}	{
			addline(yytext);
			return(LVLD);
			}
<INITIAL>{L}{V}{S}{T}	{
			addline(yytext);
			return(LVST);
			}
<INITIAL>{L}{V}{B}{L}{D}	{
			addline(yytext);
			return(LVBLD);
			}
<INITIAL>{L}{V}{B}{S}{T}	{
			addline(yytext);
			return(LVBST);
			}
<INITIAL>{V}{M}{R}{S}{E}{T}{I}	{
			addline(yytext);
			return(VMRSETI);
			}
<INITIAL>{V}{M}{R}{S}{E}{T}{F}	{
			addline(yytext);
			return(VMRSETF);
			}
<INITIAL>{V}{M}{R}{A}{N}{D}	{
			addline(yytext);
			return(VMRAND);
			}
<INITIAL>{V}{M}{R}{O}{R}	{
			addline(yytext);
			return(VMROR);
			}
<INITIAL>{V}{M}{R}{X}{O}{R}	{
			addline(yytext);
			return(VMRXOR);
			}
<INITIAL>{V}{M}{R}{N}{O}{T}	{
			addline(yytext);
			return(VMRNOT);
			}
<INITIAL>{V}{I}{N}{T}	{
			addline(yytext);
			return(VINT);
			}
<INITIAL>{V}{F}{L}{T}	{
			addline(yytext);
			return(VFLT);
			}
<INITIAL>{M}{O}{V}{V}{S}	{
			addline(yytext);
			return(MOVVS);
			}
<INITIAL>{M}{O}{V}{S}{V}	{
			addline(yytext);
			return(MOVSV);
			}
<INITIAL>{O}{R}{G}	{
			addline(yytext);
			return(ORG);
			}
<INITIAL>{E}{Q}{U}	{
			addline(yytext);
			return(EQU);
			}
<INITIAL>{D}{W}	{
		addline(yytext);
		return(DW);
		}
<INITIAL>{D}{S}	{
		addline(yytext);
		return(DS);
		}
<INITIAL>{N}{O}{P}	{
		addline(yytext);
		return(NOP);
		}
<INITIAL>{H}{L}{T}	{
		addline(yytext);
		return(HLT);
		}
<INITIAL>{M}{O}{V}	{
		addline(yytext);
		return(MOV);
		}
<INITIAL>{C}{M}{P}	{
		addline(yytext);
		return(CMP);
		}
<INITIAL>{C}{M}{P}{I}	{
		addline(yytext);
		return(CMPI);
		}
<INITIAL>{R}{C}{M}{P}	{
		addline(yytext);
		return(RCMP);
		}
<INITIAL>{R}{C}{M}{P}{I}	{
		addline(yytext);
		return(RCMPI);
		}
<INITIAL>{I}{N}{C}	{
		addline(yytext);
		return(INC);
		}
<INITIAL>{D}{E}{C}	{
		addline(yytext);
		return(DEC);
		}
<INITIAL>{C}{L}{R}	{
		addline(yytext);
		return(CLR);
		}
<INITIAL>"."{C}{O}{D}{E}	{
		addline(yytext);
		return(CODE);
		}
<INITIAL>"."{D}{A}{T}{A}	{
		addline(yytext);
		return(DATA);
		}
<INITIAL>{P}	{
		addline(yytext);
		return(P);
		}
<INITIAL>{L}{T}	{
		addline(yytext);
		return(P);
		}
<INITIAL>{M}	{
		addline(yytext);
		return(M);
		}
<INITIAL>{G}{T}	{
		addline(yytext);
		return(M);
		}
<INITIAL>{Z}	{
		addline(yytext);
		return(Z);
		}
<INITIAL>{E}{Q}	{
		addline(yytext);
		return(Z);
		}
<INITIAL>{N}{P}	{
		addline(yytext);
		return(NP);
		}
<INITIAL>{G}{E}	{
		addline(yytext);
		return(NP);
		}
<INITIAL>{N}{M}	{
		addline(yytext);
		return(NM);
		}
<INITIAL>{L}{E}	{
		addline(yytext);
		return(NM);
		}
<INITIAL>{N}{Z}	{
		addline(yytext);
		return(NZ);
		}
<INITIAL>{N}{E}	{
		addline(yytext);
		return(NZ);
		}
<INITIAL>"="	{
		addline(yytext);
		return(EQU);
		}
<INITIAL>"+"	{
		addline(yytext);
		return(ADDOP);
		}
<INITIAL>"-"	{
		addline(yytext);
		return(SUBOP);
		}
<INITIAL>"*"	{
		addline(yytext);
		return(MULOP);
		}
<INITIAL>"/"	{
		addline(yytext);
		return(DIVOP);
		}
<INITIAL>"%"	{
		addline(yytext);
		return(MODOP);
		}
<INITIAL>"&"	{
		addline(yytext);
		return(ANDOP);
		}
<INITIAL>"|"	{
		addline(yytext);
		return(OROP);
		}
<INITIAL>"^"	{
		addline(yytext);
		return(XOROP);
		}
<INITIAL>"~"	{
		addline(yytext);
		return(NOTOP);
		}
<INITIAL>">>"	{
		addline(yytext);
		return(RSFTOP);
		}
<INITIAL>"<<"	{
		addline(yytext);
		return(LSFTOP);
		}
<INITIAL>"("	{
		addline(yytext);
		return(LP);
		}
<INITIAL>")"	{
		addline(yytext);
		return(RP);
		}
<INITIAL>":"	{
		addline(yytext);
		return(COLON);
		}
<INITIAL>","	{
		addline(yytext);
		return(COMMA);
		}
<INITIAL>\n	{
		addline(yytext);
		yylval.charptr = linebuff;
		lineptr = 0;
		return(NL);
		}
<INITIAL>";"	{
		addline(yytext);
		BEGIN COMMENT;
		}
<INITIAL>"'"	{
		addline(yytext);
		strcnt = 0;
		BEGIN STR;
		}
<INITIAL>%{Z}{R}	|
<INITIAL>{Z}{R}	{
		addline(yytext);
		yylval.intvalue = 0;
		return (SR);
		}
<INITIAL>%{P}{C}	|
<INITIAL>{P}{C}	{
		addline(yytext);
		yylval.intvalue = PCREGNO;
		return (SR);
		}
<INITIAL>%{F}{R}	|
<INITIAL>{F}{R}	{
		addline(yytext);
		yylval.intvalue = N_FR;
		return (SR);
		}
<INITIAL>%{S}{P}	|
<INITIAL>{S}{P}	{
		addline(yytext);
		yylval.intvalue = N_SP;
		return (SR);
		}
<INITIAL>%{F}{P}	|
<INITIAL>{F}{P}	{
		addline(yytext);
		yylval.intvalue = N_FP;
		return (SR);
		}
<INITIAL>%{L}{R}	|
<INITIAL>{L}{R}	{
		addline(yytext);
		yylval.intvalue = LINKREG;
		return (SR);
		}
<INITIAL>%{P}{S}{L}	|
<INITIAL>{P}{S}{L}	{
		addline(yytext);
		yylval.intvalue = N_PSL;
		return (SR);
		}
<INITIAL>%{P}{S}{H}	|
<INITIAL>{P}{S}{H}	{
		addline(yytext);
		yylval.intvalue = N_PSH;
		return (SR);
		}
<INITIAL>%{V}{A}{C}{R}[0-1]	|
<INITIAL>{V}{A}{C}{R}[0-1]	{
		if (yytext[0]=='%') {
		    yylval.intvalue = atoi(&yytext[5]);
		} else {
		    yylval.intvalue = atoi(&yytext[4]);
		}
		addline(yytext);
		if ((yylval.intvalue < 0)||
		    (yylval.intvalue > 1)) {
			lexerror("invalid VACR number");
			yylval.intvalue = 0;
		}
		yylval.intvalue = N_VACR + yylval.intvalue ;
		return (SR);
		}
<INITIAL>%{V}{M}{C}{R}[0-1]	|
<INITIAL>{V}{M}{C}{R}[0-1]	{
		if (yytext[0]=='%') {
		    yylval.intvalue = atoi(&yytext[5]);
		} else {
		    yylval.intvalue = atoi(&yytext[4]);
		}
		addline(yytext);
		if ((yylval.intvalue < 0)||
		    (yylval.intvalue > 1)) {
			lexerror("invalid VMCR number");
			yylval.intvalue = 0;
		}
		yylval.intvalue = N_VMCR + yylval.intvalue ;
		return (SR);
		}
<INITIAL>%{V}{D}{C}{R}[0-1]	|
<INITIAL>{V}{D}{C}{R}[0-1]	{
		if (yytext[0]=='%') {
		    yylval.intvalue = atoi(&yytext[5]);
		} else {
		    yylval.intvalue = atoi(&yytext[4]);
		}
		addline(yytext);
		if ((yylval.intvalue < 0)||
		    (yylval.intvalue > 1)) {
			lexerror("invalid VDCR number");
			yylval.intvalue = 0;
		}
		yylval.intvalue = N_VDCR + yylval.intvalue ;
		return (SR);
		}
<INITIAL>%{V}{I}{C}{R}[0-1]	|
<INITIAL>{V}{I}{C}{R}[0-1]	{
		if (yytext[0]=='%') {
		    yylval.intvalue = atoi(&yytext[5]);
		} else {
		    yylval.intvalue = atoi(&yytext[4]);
		}
		addline(yytext);
		if ((yylval.intvalue < 0)||
		    (yylval.intvalue > 1)) {
			lexerror("invalid VICR number");
			yylval.intvalue = 0;
		}
		yylval.intvalue = N_VICR + yylval.intvalue ;
		return (SR);
		}
<INITIAL>%{V}{L}{C}{R}[0-3]	|
<INITIAL>{V}{L}{C}{R}[0-3]	{
		if (yytext[0]=='%') {
		    yylval.intvalue = atoi(&yytext[5]);
		} else {
		    yylval.intvalue = atoi(&yytext[4]);
		}
		addline(yytext);
		if ((yylval.intvalue < 0)||
		    (yylval.intvalue > 3)) {
			lexerror("invalid VLCR number");
			yylval.intvalue = 0;
		}
		yylval.intvalue = N_VLCR + yylval.intvalue ;
		return (SR);
		}
<INITIAL>%{V}{S}{C}{R}[0-3]	|
<INITIAL>{V}{S}{C}{R}[0-3]	{
		if (yytext[0]=='%') {
		    yylval.intvalue = atoi(&yytext[5]);
		} else {
		    yylval.intvalue = atoi(&yytext[4]);
		}
		addline(yytext);
		if ((yylval.intvalue < 0)||
		    (yylval.intvalue > 3)) {
			lexerror("invalid VSCR number");
			yylval.intvalue = 0;
		}
		yylval.intvalue = N_VSCR + yylval.intvalue ;
		return (SR);
		}
<INITIAL>%{G}{DECIMAL}	|
<INITIAL>%{G}{DECIMAL}{DECIMAL}	|
<INITIAL>%{G}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > GLOBAL)) {
					lexerror("invalid global SR number");
					yylval.intvalue = 0;
				}
				return (SR_G);
				}
<INITIAL>%{L}{DECIMAL}	|
<INITIAL>%{L}{DECIMAL}{DECIMAL}	|
<INITIAL>%{L}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > LOCAL)) {
					lexerror("invalid local SR number");
					yylval.intvalue = 0;
				}
				return (SR_L);
				}
<INITIAL>%{F}{DECIMAL}	|
<INITIAL>%{F}{DECIMAL}{DECIMAL}	|
<INITIAL>%{F}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > OVERLAP)) {
					lexerror("invalid forward overlap SR number");
					yylval.intvalue = 0;
				}
				return (SR_F);
				}
<INITIAL>%{B}{DECIMAL}	|
<INITIAL>%{B}{DECIMAL}{DECIMAL}	|
<INITIAL>%{B}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > OVERLAP)) {
					lexerror("invalid backward overlap SR number");
					yylval.intvalue = 0;
				}
				return (SR_B);
				}
<INITIAL>%{R}{DECIMAL}	|
<INITIAL>%{R}{DECIMAL}{DECIMAL}	|
<INITIAL>%{R}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > ALL)) {
					lexerror("invalid SR number");
					yylval.intvalue = 0;
				}
				return (SR);
				}
<INITIAL>{S}{R}{DECIMAL}	|
<INITIAL>{S}{R}{DECIMAL}{DECIMAL}	|
<INITIAL>{S}{R}{DECIMAL}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > ALL)) {
					lexerror("invalid SR number");
					yylval.intvalue = 0;
				}
				return (SR);
				}
<INITIAL>{V}{R}{DECIMAL}	|
<INITIAL>{V}{R}{DECIMAL}{DECIMAL}	{
				addline(yytext);
				yylval.intvalue = atoi(&yytext[2]);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > 63)) {
					lexerror("invalid VR number");
					yylval.intvalue = 0;
				}
				return (VR);
				}
<INITIAL>{C}{N}[0-7]		{
				yylval.intvalue = atoi(&yytext[2]);
				addline(yytext);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > 7)) {
					lexerror("invalid CN number");
					yylval.intvalue = 0;
				}
				return (CN);
				}
<INITIAL>{V}{M}{R}[0-7]	{
				yylval.intvalue = atoi(&yytext[3]);
				addline(yytext);
				if ((yylval.intvalue < 0)||
				    (yylval.intvalue > 7)) {
					lexerror("invalid VMR number");
					yylval.intvalue = 0;
				}
				return (VMR);
				}
<INITIAL>[_A-Za-z][_A-Za-z0-9]*	{
				yylval.charptr = strdup(yytext);
				allupper(yylval.charptr);
				addline(yytext);
				return (LABEL);
				}
<INITIAL>{DECIMAL}+		{
				yylval.intvalue = atoi(yytext);
				addline(yytext);
				return (INTVAL);
				}
<INITIAL>"-"?{DECIMAL}+"."{DECIMAL}*{EXP}? |
<INITIAL>"-"?{DECIMAL}*"."{DECIMAL}+{EXP}? |
<INITIAL>"-"?{DECIMAL}+{EXP}	{
				addline(yytext);
				yylval.floatvalue = (float)atof(yytext);
				return (FLOATVAL);
				}
<INITIAL>{DECIMAL}{HEXA}*[hH]	{
				addline(yytext);
				if (htoi(yytext,&yylval.intvalue)==0) {
					return (INTVAL);
				} else { /* hexadecimal str too long */
					lexerror("too long hexadecimal const.");
					return (INTVAL);
				}
				}
<INITIAL>[01]+[bB]		{
				addline(yytext);
				if (btoi(yytext,&yylval.intvalue)==0) {
					return (INTVAL);
				} else { /* binary str too long */
					lexerror("too long binary const.");
					return (INTVAL);
				}
				}
<INITIAL>[ \t]	{
		addline(yytext);
		}
<INITIAL>.	{
		addline(yytext);
		lexerror("invalid character");
		}
<STR>"'"	{
		addline(yytext);
		if (strcnt >= STRSIZE) {
			lexerror("string size too long");
		}
		string[strcnt] = (char)NULL;
		yylval.charptr = strdup(string);
		BEGIN INITIAL;
		return (STRING);
		}
<STR>\\"'"	{
		addline(yytext);
		if (strcnt < STRSIZE) string[strcnt++] = '\'';
		}
<STR>\\n	{
		addline(yytext);
		if (strcnt < STRSIZE) string[strcnt++] = '\n';
		}
<STR>\n		{
		lexerror("string not closed");
		if (strcnt >= STRSIZE) {
			lexerror("string size too long");
		}
		string[strcnt] = (char)NULL;
		yylval.charptr = strdup(string);
		unput('\n');
		BEGIN INITIAL;
		return (STRING);
		}
<STR>.		{
		addline(yytext);
		if (strcnt < STRSIZE) string[strcnt++] = yytext[0];
		}
<COMMENT>.	{
		addline(yytext);
		}
<COMMENT>\n	{
		addline(yytext);
		yylval.charptr = linebuff;
		lineptr = 0;
		BEGIN INITIAL;
		return(NL);
		}
%%
/* printout lex errormessage */
void lexerror(s)
char *s;
{
	extern int yynerrs, yylineno;

	++yynerrs;
	fprintf(stderr,"%d: %s\n",yylineno,s);
}

/* append to linebuff */
void addline(str)
char *str;
{
	int	i;
	extern 	int	lineptr;

	for (i = 0 ; i < strlen(str) ; i++) {
		linebuff[lineptr++] = str[i];
	}

	linebuff[lineptr] = (char)NULL;
}

/* convert hexadecimal string to integer */
int htoi(cp,retval)
char *cp;
int  *retval;
{	
	char	tmp[HEXSTRLEN];
	int	slen;

	if ((slen = strlen(cp)) > HEXSTRLEN) {
		*retval = 0;
		return (-1);
	}
	
	strncpy(tmp,cp,slen-1);
	tmp[slen] = (char)NULL;

	*retval = (int)strtol(tmp,(char **)NULL,16);
	return (0);
}

/* convert binary string to integer */
int btoi(cp,retval)
char *cp;
int  *retval;
{	
	char	tmp[BINSTRLEN];
	int	slen;

	if ((slen = strlen(cp)) > BINSTRLEN) {
		*retval = 0;
		return (-1);
	}
	
	strncpy(tmp,cp,slen-1);
	tmp[slen] = (char)NULL;

	*retval = (int)strtol(tmp,(char **)NULL,2);
	return (0);
}

/* convert string to uppercase */
void allupper(cp)
char *cp;
{
	int	i;

	for (i = 0 ; i < strlen(cp) ; i++) {
		cp[i] = toupper(cp[i]);
	}
}
