/* defines and global variables for asm3v ver.1.0 ['92/Aug/5-11] */
/* 					  ver.1.1 ['92/Aug/22]   */
/* 					  ver.1.3 ['96/May/22]   */

#include "global.h"

#define	TRUE	1
#define FALSE	0

/* word union (int & float) */
typedef union {
	int	i;
	unsigned int	u;
	float	f;
} word ;

/* label node struct */
struct l_node {
	char *labelname;
	int	labelvalue;
	int	initialized;
	struct l_node *next;
} ;

typedef struct l_node labelnode;

global labelnode *root init((labelnode *)NULL);

/* label control functions */
extern labelnode *labelnodealloc();
extern labelnode *addlabel();
extern labelnode *addlabelandinit();
extern int	 getlabelvalue();

/* enable uninitialized label used error flag default value*/
global	int	uninitlabelerrdefault init(FALSE);

/* assemble pass */
global	int	pass init(1);

/* current PC */
global	int     currentpc init(0);

/* DW pseudo instruction counter's maxlen & buffer */
global	int	maxdwc init(0);
global 	word	*dwbuff;

/* listing file output */
extern	void	listoutwithinst();
extern	void	listoutwithpc();
extern	void	listoutcmnt();
extern	void	listoutlabellist();

/* object file output */
extern	void	objectaddrout();
extern	void	objectout();

/* assemble mode flags */
#define CODE_MODE	0	/* code mode */
#define DATA_MODE	1	/* data mode */

global	int	asmmode	init(CODE_MODE);

/* pseudo load immediate float (PLDIF) */
#define MAXPLDIF	100		/* maximum PLDIF count */
global	int	pldifcount	init(0);	/* PLDIF count */
global	word	pldifvalue[MAXPLDIF];		/* PLDIF value */
global	int	pldifdwbase;			/* PLDIF DW area base addr */

/* pseudo load immediate int (PLDII) (for >17bit int) */
#define MAXPLDII	100		/* maximum PLDII count */
global	int	pldiicount	init(0);	/* PLDII count */
global	word	pldiivalue[MAXPLDII];		/* PLDII value */
global	int	pldiidwbase;			/* PLDII DW area base addr */

/* pseudo load immediate DW output */
extern void	outputpldidw();
