/* main program for asm3v ver.1.0 ['92/Aug/8-Aug/11] */
/* 			  ver.1.1 ['92/Aug/22] */
/* 			  ver.1.3 ['92/Sep/1-2] */
/* 			  ver.1.3R['93/Oct/26] */

/* main program for asm4v ver.1.0 ['94/Jun/10] */
/* 			  ver.1.3 ['96/May/22] */

#define	MAINPROGRAM

#include <stdio.h>
#include "defines.h"
#include "ipconst.h"

FILE	*source,*list,*object;
extern	FILE	*yyin;
extern	int	yyparse();
extern	int	yylineno;
extern	int	yynerrs;

main(argc,argv)
int	argc;
char 	**argv;
{
	char	basename[256];
	char	sourcename[256];
	char	listname[256];
	char	objectname[256];

	if (argc == 2) {
		if (strcmp(&argv[1][strlen(argv[1])-4],".asm") == 0) {
			strncpy(basename,argv[1],strlen(argv[1])-4);
			basename[strlen(argv[1])-4] = (char) NULL;
		} else {
			strcpy(basename,argv[1]);
		}
		strcpy(sourcename,basename);
		strcat(sourcename,".asm");
		strcpy(listname,basename);
		strcat(listname,".lst");
		strcpy(objectname,basename);
		strcat(objectname,".obj");
	} else {
		fprintf(stderr,"usage: %s soucefilename\n",argv[0]);
		exit(1);
	}

	if ((source = fopen(sourcename,"r")) == NULL) {
		fprintf(stderr,"sourcefile %s open failed\n",sourcename);
		exit(1);
	}
	
	if ((object = fopen(objectname,"w")) == NULL) {
		fprintf(stderr,"objectfile %s open failed\n",objectname);
		exit(1);
	}
	
	if ((list = fopen(listname,"w")) == NULL) {
		fprintf(stderr,"listfile %s open failed\n",listname);
		exit(1);
	}

	yyin = source;

	/* pass 1 */

	pass = 1;
	currentpc = 0;
	pldifcount = 0;
	pldiicount = 0;
	uninitlabelerrdefault = FALSE;
	asmmode = CODE_MODE;

	yyparse();

	if (yynerrs != 0) {
		fprintf(stderr,"%d error(s) found in pass 1. aborted.\n",yynerrs);
		exit(1);
	} else {
		fprintf(stderr,"no error found in pass 1.\n");
	}

	pldifdwbase = currentpc;
	pldiidwbase = currentpc + pldifcount;

	rewind(yyin);

	/* pass 2 */

	dwbuff = (word *)malloc((sizeof (word)) * maxdwc);

	pass = 2;
	currentpc = 0;
	pldifcount = 0;
	pldiicount = 0;
	uninitlabelerrdefault = TRUE;
	yylineno = 0;
	asmmode = CODE_MODE;

	yyparse();

	if (yynerrs != 0) {
		fprintf(stderr,"%d error(s) found in pass 2. aborted.\n",yynerrs);
		exit(1);
	} else {
		fprintf(stderr,"no error found in pass 2.\n");
	}

	outputpldidw();		/* output PseudoLDI DW const */
	listoutlabellist();	/* output label list */

	fclose(source);
	fclose(object);
	fclose(list);
	
	exit(0);
}

void outputpldidw()
{
	int	i;
	char	line[100];

	asmmode = DATA_MODE;


	if (pldifcount != 0) {
	    if (list != NULL) {
		    fprintf(list,"\n");
	    }
	    objectaddrout(pldifdwbase);
	    for (i=0 ; i < pldifcount ; i++) {
		objectout(pldifvalue[i].i);
		sprintf(line,"DW	%f	;for PLDI(float)\n",pldifvalue[i].f);
		listoutwithinst(pldifdwbase+i,pldifvalue[i].i,line);
	    }
	}
	if (pldiicount != 0) {
	    if (list != NULL) {
		    fprintf(list,"\n");
	    }
	    objectaddrout(pldiidwbase);
	    for (i=0 ; i < pldiicount ; i++) {
		objectout(pldiivalue[i].i);
		sprintf(line,"DW	%i	;for PLDI(int)\n",pldiivalue[i].i);
		listoutwithinst(pldiidwbase+i,pldiivalue[i].i,line);
	    }
	}
}
		
void objectaddrout(addr)
int	addr;	/* instruction address */
{
	if (object != NULL) {
		fprintf(object,":%08X\n",addr);
	}
}

void objectout(inst)
int	inst;	/* instruction word */
{
	if (object != NULL) {
		fprintf(object,"%08X\n",inst);
	}
}

void listoutwithinst(pc,inst,line)
int	pc;	/* program counter */
int	inst;	/* instruction word */
char	*line;	/* source line */
{
	if (list != NULL) {
	    if (NIP == 1) {
		fprintf(list,"   %08X  %08X   %s",pc,inst,line);
	    } else {
		if (asmmode == CODE_MODE) {
		    fprintf(list,"P%1d:%08X  %08X   %s",pc % NIP,pc,inst,line);
		} else { /* DATA_MODE */
		    fprintf(list,"   %08X  %08X   %s",pc,inst,line);
		}
	    }
	}
}

void listoutwithpc(pc,line)
int	pc;	/* program counter */
char	*line;	/* source line */
{
	if (list != NULL) {
		fprintf(list,"   %08X             %s",pc,line);
	}
}

void listoutequ(value,line)
char	*value;	/* label value */
{
	if (list != NULL) {
		fprintf(list,"             %08X   %s",value,line);
	}
}

void listoutcmnt(line)
char	*line;	/* source line */
{
	if (list != NULL) {
		fprintf(list,"                        %s",line);
	}
}

void listoutlabellist()
{
	int	count;
	labelnode *lnp;

	count = 0;
	lnp = root;

	if ((list != NULL)&&(lnp != NULL)) {
		fprintf(list,"\n\n\nLABELS:\n\n");
		while (lnp != NULL) {
			fprintf(list,"%08X %-13.13s  ",
				lnp->labelvalue,
				lnp->labelname);
			if ((++count % 3)==0) fprintf(list,"\n");
			lnp = lnp->next;
		}
		fprintf(list,"\n");
	}
}
